import {ProxyObserver} from '@schukai/monster/source/types/proxyobserver.mjs';
import {Observer} from '@schukai/monster/source/types/observer.mjs';
import {isObject} from '@schukai/monster/source/types/is.mjs';

const o = new Observer(function () {
    if (isObject(this) && this instanceof ProxyObserver) {
        // do something (this ist ProxyObserver)
        const subject = this.getSubject();
        console.log(subject);
    }
});

let realSubject = {
    a: {
        b: {
            c: true
        },
        d: 9
    }
}

const p = new ProxyObserver(realSubject);
p.attachObserver(o);
const s = p.getSubject();
s.a.b.c = false;
